process IItpc_image (x,y,z,file,graph,size)
begin
    signal(id,s_freeze);
    frame;
end


process IIp_counting_game (int tcg_tiempo)
private
    int tcg_graf_numeros;
    int tgc_graf_sombras_numeros;
    int tgc_graf_interfaz;
    int tgc_ant_segundo;
    
    int tgc_text_map[2];
    int tgc_text_map_graph[2];
    
    int hijo_cronometro;
    int hijo_contador[1];
    int hijo_sonido_reloj;
    int hijos_interfaz[3];
    int hijos_mensajes[5];
    //int hijos_temp[2];
    
    int tgc_resultado1;
    int tgc_resultado2;
    int tgc_vencedor;
    
    int cont;
    int cont_sonidos;
    int temp_signal;
    //int temp_graph[2];
begin
    //Carga de recursos
    tcg_graf_numeros=load_fpg("grafs/numbers.fpg");
    tgc_graf_sombras_numeros=load_fpg("grafs/s_numbers.fpg");
    tgc_graf_interfaz=load_fpg("grafs/count_interface.fpg");
    //Elementos de pantalla
    hijo_cronometro=crear_cronometro(tcg_graf_numeros,tgc_graf_sombras_numeros, 160-78, 0, 0, tcg_tiempo, 0);
    hijo_contador[0]=contador_pulsaciones(12, 75, 0, tcg_graf_numeros,tgc_graf_sombras_numeros, 200,
                                       _KEY_1, &tgc_resultado1);
    hijo_contador[1]=contador_pulsaciones(170, 75, 0, tcg_graf_numeros,tgc_graf_sombras_numeros, 200,
                                       _KEY_2, &tgc_resultado2);
    hijos_interfaz[1]=sombra_fija( 23,175,1,tgc_graf_interfaz,2);   //Ready
    hijos_interfaz[2]=sombra_fija(115,175,1,tgc_graf_interfaz,4);   //Set
    hijos_interfaz[3]=sombra_fija(208,175,1,tgc_graf_interfaz,6);   //Go
    switch (OS_ID)
    case 7,8,9:   //GP2X, WIZ, CAANOO
        set_text_color(rgb(0,64,21));
        tgc_text_map[0]=write_in_map(0,"Press A button",1);
        tgc_text_map[1]=write_in_map(0,"Press B button",1);
        tgc_text_map[2]=write_in_map(0,"Press SELECT to exit",7);
        set_text_color(rgb(170,225,190));
        tgc_text_map_graph[0]=write_in_map(0,"Press A button",1);
        tgc_text_map_graph[1]=write_in_map(0,"Press B button",1);
        tgc_text_map_graph[2]=write_in_map(0,"Press SELECT to exit",7);
    end
    default:    //PC
        set_text_color(rgb(0,64,21));
        tgc_text_map[0]=write_in_map(0,"Press LEFT CURSOR",1);
        tgc_text_map[1]=write_in_map(0,"Press P key",1);
        tgc_text_map[2]=write_in_map(0,"Press ENTER to exit",7);
        set_text_color(rgb(170,225,190));
        tgc_text_map_graph[0]=write_in_map(0,"Press LEFT CURSOR",1);
        tgc_text_map_graph[1]=write_in_map(0,"Press P key",1);
        tgc_text_map_graph[2]=write_in_map(0,"Press ENTER to exit",7);
    end
    end //switch
    hijos_mensajes[0]=IItpc_image(86,150,0,0,tgc_text_map[0],100);
    hijos_mensajes[1]=sombra_fija(86,150,1,0,tgc_text_map_graph[0]);
    hijos_mensajes[2]=IItpc_image(234,150,0,0,tgc_text_map[1],100);
    hijos_mensajes[3]=sombra_fija(234,150,1,0,tgc_text_map_graph[1]);
    
    hijos_mensajes[5]=sombra_fija(160,235,1,0,tgc_text_map_graph[2]);
    
    
    //Compas de espera
    canal_short_alarm=play_wav(sonido_short_alarm,0);
    frame(7500);
    hijos_interfaz[0]=IItpc_image(23,175,0,tgc_graf_interfaz,1,100);
    canal_short_alarm=play_wav(sonido_short_alarm,0);
    frame(7500);
    hijos_interfaz[0].x=115;
    hijos_interfaz[0].graph=3;
    canal_short_alarm=play_wav(sonido_short_alarm,0);
    frame(7500);
    hijos_interfaz[0].x=208;
    hijos_interfaz[0].graph=5;
    canal_long_alarm=play_wav(sonido_long_alarm,0);
    frame(10000);
    if (exists(hijos_interfaz[0])) signal(hijos_interfaz[0],s_kill); end
    
    //Adelante!!!!
    hijo_sonido_reloj=lcd_cronometro_sound();
    reloj_data.run=true;
    run_contar=true;
    while (!reloj_data.end_count)
        frame;
    end
    run_contar=false;
    
    //Fin de la partida
    signal(hijos_mensajes[0],s_sleep);  //Desconectamos los mensaje de los botones a pulsar repetidamente
    signal(hijos_mensajes[2],s_sleep);
    hijos_mensajes[4]=Itpc_image(160,235,0,0,tgc_text_map[2],100);  //Activamos mensaje de exit
    //Comprobacin del vencedor
    frame;
    //say(tgc_resultado1 +"    "+ tgc_resultado2);
    if (tgc_resultado1 == tgc_resultado2)
        tgc_vencedor=3;
    elsif (tgc_resultado1 > tgc_resultado2)
        tgc_vencedor=1;
    else
        tgc_vencedor=2;
    end
    //Parpadeo de los puntos (usa sleep/freeze contra el vencedor)*************
    canal_long_alarm=play_wav(sonido_long_alarm,0);
    temp_signal=s_sleep_tree;
    cont_sonidos=0;
    while (teclas[_KEY_INTRO] != 1)
        if (tgc_ant_segundo != rtc_reloj.ss2)
            //Parpadeamos los contadores ganadores
            if (tgc_vencedor & 1) signal(hijo_contador[0],temp_signal); end
            if (tgc_vencedor & 2) signal(hijo_contador[1],temp_signal); end
            signal(type sombra_fija,s_wakeup);  //Evita que las sombras desaparezcan
            signal(hijos_mensajes[4],temp_signal);  //Parpadea mensaje de exit
            
            if (temp_signal == s_sleep_tree)    //Cambiamos la seal
                temp_signal=s_freeze_tree;
            else
                temp_signal = s_sleep_tree;
                if (cont_sonidos < 3)   //Ponemos sonido con la aparicin de los contadores
                    canal_long_alarm=play_wav(sonido_long_alarm,0);
                    cont_sonidos++;
                end
            end
            tgc_ant_segundo=rtc_reloj.ss2;
        end
        frame;
    end
    
    //Descarga de recursos
    if (exists(hijo_cronometro)) signal(hijo_cronometro,s_kill_tree); end
    for (cont=0;cont<=1;cont++)
        if (exists(hijo_contador[cont])) signal(hijo_contador[cont],s_kill_tree); end
    end
    if (exists(hijo_sonido_reloj)) signal(hijo_sonido_reloj,s_kill); end
    if (exists(hijos_interfaz[1])) signal(hijos_interfaz[1],s_kill); end
    if (exists(hijos_interfaz[2])) signal(hijos_interfaz[2],s_kill); end
    if (exists(hijos_interfaz[3])) signal(hijos_interfaz[3],s_kill); end
    for (cont=0;cont<=5;cont++)
        if (exists(hijos_mensajes[cont])) signal(hijos_mensajes[cont],s_kill); end
    end
    
    unload_fpg(tcg_graf_numeros);
    unload_fpg(tgc_graf_sombras_numeros);
    unload_fpg(tgc_graf_interfaz);
    for (cont=0;cont<=2;cont++)
        unload_map(0,tgc_text_map[cont]);
        unload_map(0,tgc_text_map_graph[cont]);
    end
    
    signal (father,s_wakeup);
    frame;
end
