//****************************************************
//  CLCULO DEL DESPLAZAMIENTO DE LA SOMBRA
//****************************************************
process sombra_calcula_desplazamiento ()
private
    int temp;
begin
    priority=999;
    loop
        temp=inclinacion_lateral-inclinacion_lateral_default;
        sombra_desp_x = 5 * sin(temp*1000);
        temp=inclinacion_vertical-inclinacion_vertical_default;
        sombra_desp_y = -5 * sin(temp*1000);
        frame;
    end
end

//****************************************************
//  SOMBRA QUE PERMANECE FIJA E INALTERABLE
//****************************************************
process sombra_fija (int sf_x2,int sf_y2,z,file,graph)
begin
    loop
        x=sf_x2+sombra_desp_x;
        y=sf_y2+sombra_desp_y;
        frame;
    end
end

//****************************************************
//  SOMBRA QUE SIGUE AL PROCESO QUE SE LE INDIQUE
//  SIN CAMBIAR SU GRFICO
//****************************************************
process sombra_cinetica (int sc_id_seguir, file, graph)
begin
    loop
        if (exists(sc_id_seguir))
            x=sc_id_seguir.x+sombra_desp_x;
            y=sc_id_seguir.y+sombra_desp_y;
            z=sc_id_seguir.z+10;
            angle=sc_id_seguir.angle;
        end
        frame;
    end
end

//****************************************************
//  SOMBRA QUE SIGUE AL PROCESO QUE SE LE INDIQUE Y
//  CAMBIA SU GRFICO POR EL MISMO (PERO EN OTRO FPG)
//****************************************************
process sombra_dinamica (int sc_id_seguir, file, graph)
begin
    loop
        if (exists(sc_id_seguir))
            x=sc_id_seguir.x+sombra_desp_x;
            y=sc_id_seguir.y+sombra_desp_y;
            z=sc_id_seguir.z+10;
            angle=sc_id_seguir.angle;
            graph=sc_id_seguir.graph;
        end
        frame;
    end
end
